package Util;

use strict;
use warnings;

use Exporter;
our @ISA = qw(Exporter);
our @EXPORT_OK = qw(untaint_filename untaint_path);

use Carp;

sub untaint_filename
{
  scalar(@_) == 1
    or croak "untaint_filename accepts only one argument";
  
  my $filename = shift;
  croak "Undefined filename" unless defined($filename);
  $filename =~ /^([^\/\\\000*?]+)$/
    or croak "Invalid characters in filename $filename";
  return $1;
}

sub untaint_path
{
  scalar(@_) == 1
    or croak "untaint_filename accepts only one argument";
  
  my $filename = shift;
  croak "Undefined filename" unless defined($filename);
  $filename =~ /^([^\000*?]+)$/
    or croak "Invalid characters in filename $filename";
  return $1;
}

1;
