package first;

use strict;
use warnings;

my %used_from;

sub import
{
  shift; # Drop class name
  my @packages = @_;
  my $sub = pop @packages;
  my $sub_name;

  if ($sub =~ s/^>//) {
    # If $sub begins with '>', we have a rename case and must read
    # previous argument for the real subroutine name
    $sub_name = pop @packages;
  } else {
    ($sub_name) = ($sub =~ /([^:]*)$/);
  }
  # Qualify $sub with caller package name if it is unqualified
  $sub = scalar(caller) . "::$sub" if ($sub !~ /::/);

  for my $package (@packages) {
    no strict 'refs';
    if ($package eq 'CORE') {
      *{$sub} = sub {return eval "${package}::$sub_name(@_)";};
      $used_from{$sub} = "${package}::$sub_name";
      return 1;
    }
    eval "require $package";
    if (exists &{"${package}::$sub_name"}) {
      *{$sub} = \&{"${package}::$sub_name"};
      $used_from{$sub} = "${package}::$sub_name";
      return 1;
    } elsif (defined *{"${package}::EXPORT_OK"}{ARRAY}) {
      foreach my $item (@{"${package}::EXPORT_OK"}) {
        if ($sub_name eq $item) {
          *{$sub} = \&{"${package}::$sub_name"};
          $used_from{$sub} = "${package}::$sub_name";
          return 1;
        }
      }
    }
  }
  return 0;
}

sub used_from
{
  my $class = shift;
  my $sub = shift;

  # Qualify $sub with caller package name if it is unqualified
  $sub = scalar(caller) . "::$sub" if ($sub !~ /::/);
  return $used_from{$sub};
}

1;