package XServProcessor;

use IO::Socket;
# use XServUtils;
# use Data::Dumper;

my @StrTSR = qw (NodeIP NodeId CPUType CPUCores CPUFreq CPUPerf RAMSize OSType ZZ);
# my @StrREQ = qw (NodeIP NodeId TaskName TaskId SessionId);
my @StrREQ = qw (SessionId);
my @StrASW = qw (SessionId PortionNumber PortionTimer Data);

#my $EOL = "\015\012";
my $EOL = "\n";
my $END_OF_SEND = "<xcom_end>";

$SIG{PIPE} = 'IGNORE';

sub main
{
  my $FirstPortionNumber; 
  my $LastPortionNumber;
  my $LastAskedPortion=-1;
  my $SentPortionsCount=0;
  my $UniqueSentPortionsCount=0;
  my $ReceivedPortionsCount=0;
  my $UniqueReceivedPortionsCount=0;
  my @PortionsInProcess;
  my %PortionsInProcessIndex;
  my %Nodes=();
  my %UniqueNodesKeys=();
  my %NodesASWCount=();
  my $TotalNodesCount=0;
  my $TotalUniqueNodesCount=0;
  my $TotalPeakPerformance=0;
  my %PortionsStatus=();
#  my %PortionsInProcessKeys;
  my $CurrentPortion;
#  my $TotalPortions;
  my $ErrCode=0;
  my $RequestsPerMinute=0;
  # my $LastRequestTime = 0;
  # my $CurrTime;
  my $TaskServer;
#  XServAPI::Initialize();
  $FirstPortionNumber=XServAPI::GetFirstPortionNumber();
  $LastPortionNumber=XServAPI::GetLastPortionNumber();
  print STDERR "XServProcessor: $::ts_taskName initialized ($FirstPortionNumber -> $LastPortionNumber)\n";

  if ($::ts_singlePortion == 1)
  {
    $SIG{ALRM} = \&return;
    # alarm ($::ts_clientWait);
  }
  
  if (!defined ($::ts_prSock))
  {
    $TaskServer = IO::Socket::INET->new(LocalPort => $::ts_prPort, Type => SOCK_STREAM, ReuseAddr => 1, Listen => SOMAXCONN, Proto => "tcp", Blocking => 1)
      or die ("TaskServer: can't create socket (INET)!\n");
  }
  else
  {
    unlink ($::ts_prSock);
    $TaskServer = IO::Socket::UNIX->new(Type => SOCK_STREAM, Local => $::ts_prSock, Listen => SOMAXCONN)
      or die ("TaskServer: can't create socket $::ts_prSock (UNIX)!\n");
  }
  binmode $TaskServer;
  my $time4RPM = time();
  my ($pStart, $pEnd, $pInt) = (0, 0, 0);
  # while ( (my $SubServer=$TaskServer->accept()) || ((($CurrTime=time())-$LastRequestTime) > $::ts_portionWait) )
  while (my $SubServer=$TaskServer->accept())
  {
#my $time0 = time();
    # return if (($CurrTime-$LastRequestTime) > $::ts_portionWait);
    if ((my $tmpt=time())-$time4RPM > 60) { $time4RPM = $tmpt; $RequestsPerMinute=0 }
    # else { $RequestsPerMinute++ }
    binmode $SubServer;
    my $iline=0;
    my %SSReq=();
#print STDERR "<A>\n";
    while (defined(my $line=<$SubServer>))
    {
#print STDERR 'SS<<'.$line;
      my $oline = $line;
      chomp $line;
      #last if ((defined($SSReq{ReqType})) && ($SSReq{ReqType} ne 'ASW') && ($line eq ''));
      #last if $line eq ''; # && !(defined($SSReq{ReqType}) && $SSReq{ReqType} eq 'ASW');
      last if ((($line eq '') && ($SSReq{ReqType} ne 'ASW')) || (($line eq $END_OF_SEND) && ($SSReq{ReqType} eq 'ASW')));
      if ($iline==0) 
      { 
	if ( ($line eq 'TSR') || ($line eq 'REQ') || ($line eq 'ASW') || ($line eq 'STA') || ($line eq 'INI') )
	{
          $SSReq{ReqType}=$line;
        }
        else
        {
	  print STDERR "P> Incorrect request!\n";
          close $SubServer;
          last;
        }
      }
      elsif (defined($SSReq{ReqType}))
      {
	if ($SSReq{ReqType} eq 'TSR') { $SSReq{$StrTSR[$iline-1]}=$line; }
	elsif ($SSReq{ReqType} eq 'REQ') { $SSReq{$StrREQ[$iline-1]}=$line }
	elsif ($SSReq{ReqType} eq 'ASW') 
	{ 
	  if ($iline<4) { $SSReq{$StrASW[$iline-1]}=$line }
	  else { $SSReq{Data}.=$oline }
	}
      }
      $iline++;
#print STDERR "SS: '$line'\n";
      #last if $line eq '';
    }
    next if $iline == 0;
#print STDERR "<B> ".length($SSReq{Data})."\n";
#my $time1 = time();
#print STDERR "@{[%SSReq]}\n";
#print STDERR "Q\n";
    my @Data4SServer=();
    if (($SSReq{ReqType} eq 'REQ') && exists($Nodes{$SSReq{SessionId}}) && !(($LastAskedPortion==$LastPortionNumber) && ($::ts_singlePortion==1)))
    {
      if ($::ts_taskAPI ne 'Proxy')
      {
        if ($LastAskedPortion==$LastPortionNumber) { $CurrentPortion=shift(@PortionsInProcess) }
        elsif ($LastAskedPortion==-1) { $LastAskedPortion=$FirstPortionNumber; $CurrentPortion=$LastAskedPortion; }
        else { $CurrentPortion=++$LastAskedPortion }
      }
      else
      {
	$CurrentPortion = shift(@::InBufferPortions);
	$LastAskedPortion = $CurrentPortion;
      }
#print STDERR "P> inBP: ".@::InBufferPortions."\n";
      push (@PortionsInProcess, $CurrentPortion);

      print $SubServer $CurrentPortion.$EOL.XServAPI::GetPortionArgs($CurrentPortion).$EOL;
      $pStart = Time::HiRes::time();
      if ( defined($::ts_prSock) && (($::ts_taskAPI eq 'Files') || ($::ts_taskAPI eq 'Proxy')) )
      {
        my $pf = XServAPI::GetPortionInFile($CurrentPortion);
	$pEnd = Time::HiRes::time();
	$pInt = $pEnd - $pStart;
	print $SubServer $pInt.$EOL.$pf;
      }
      else
      {
        my $fh = XServAPI::GetPortion($CurrentPortion);
	$pEnd = Time::HiRes::time();
	$pInt = $pEnd - $pStart;
	print $SubServer $pInt.$EOL;
        while (my $line=<$fh>)
        {
          print $SubServer $line;
        }
	close ($fh);
      }

      ${Nodes{$SSReq{SessionId}}}{Portion} = $CurrentPortion;
      ${Nodes{$SSReq{SessionId}}}{Start} = time();
      $UniqueSentPortionsCount++ if (!defined($PortionsStatus{$CurrentPortion}));
      $PortionsStatus{$CurrentPortion}=1;
      $SentPortionsCount++;
#print STDERR "PortionsInProcess = (@PortionsInProcess)\n";
      if ($::ts_taskAPI eq 'Proxy' && ($::ts_inBufferSize < $::ts_inBufferMin) )
      {
        if (my $delta = XServProxy::proxyGetPortions ($::ts_inBufferMax-$::ts_inBufferSize, "$::ts_proxyTmp/$::ts_taskName.$::ts_taskId.$::ts_sessId/in"))
        {	
          $::ts_inBufferSize += $delta;
        }
	  else
        {
	  # re-initialize
	  print STDERR "XServProcessor(REQ/proxy): new task detected, restarting XServProcessor\n";
	  # XServProxy::proxyInit();
	  return 1;
        }
      }
      $RequestsPerMinute++;
      print "P> ".${Nodes{$SSReq{SessionId}}}{Id}.": REQ $CurrentPortion\n" if !$::ts_debugHideProcessorOut;
      alarm ($::ts_portionWait) if ($::ts_singlePortion == 1) && ($LastAskedPortion==$LastPortionNumber) && ($::ts_portionWait > 0);
    }
    elsif (($SSReq{ReqType} eq 'ASW') && exists($Nodes{$SSReq{SessionId}}))
    {
#print STDERR 'P-ASW> '.$SSReq{PortionNumber}."\n";
#print STDERR "<C>\n";
      chomp $SSReq{Data};
#print STDERR "<D>\n";
      # $SSReq{Data} =~ s/<NxcomN>/\n\n/;
      my $prtn=0;
      foreach my $prt (@PortionsInProcess)
      {
        if ($prt == $SSReq{PortionNumber}) { last } else { $prtn++ }
      }
      splice (@PortionsInProcess, $prtn, 1);
      $UniqueReceivedPortionsCount++ if $PortionsStatus{$SSReq{PortionNumber}}!=2;
      $ReceivedPortionsCount++;
      if ( $::ts_keepFirst == 0 || ($::ts_keepFirst == 1 && ($PortionsStatus{$SSReq{PortionNumber}}==1)) )
      {
	$pStart = Time::HiRes::time();
	if ( defined($::ts_prSock) && (($::ts_taskAPI eq 'Files') || ($::ts_taskAPI eq 'Proxy')) )
	{
          XServAPI::AddPortionFromFile ($SSReq{PortionNumber}, $SSReq{Data});
	} else {
#print STDERR "<E>\n";
	  XServAPI::AddPortion ($SSReq{PortionNumber}, \$SSReq{Data});
#print STDERR "<F>\n";
	}
	$pEnd = Time::HiRes::time();
	$pInt = $pEnd - $pStart;
	$PortionsStatus{$SSReq{PortionNumber}}=2;
        if ($::ts_taskAPI eq 'Proxy' && $::ts_outBufferSize >= $::ts_outBufferMax)
        {
          if (my $delta = XServProxy::proxySendPortions ($::ts_outBufferMin, "$::ts_proxyTmp/$::ts_taskName.$::ts_taskId.$::ts_sessId/out"))
	  { 
	    $::ts_outBufferSize -= $delta;
	  }
	  else
	  {
	    # re-initialize
	    print STDERR "XServProcessor(ASW/proxy): new task detected, restarting XServProcessor\n";
	    # XServProxy::proxyInit();
	    return 1;
	  }
        }
      }
      # push (@Data4SServer, 'OK');
      push (@Data4SServer, $pInt);
# print STDERR "ASW: pInt = $pInt\n";
      ${Nodes{$SSReq{SessionId}}}{PreLastTime} = ${Nodes{$SSReq{SessionId}}}{LastTime};
      # ${Nodes{$SSReq{SessionId}}}{LastTime} = time()-${Nodes{$SSReq{SessionId}}}{Start};
      ${Nodes{$SSReq{SessionId}}}{LastTime} = $SSReq{PortionTimer};
      ${Nodes{$SSReq{SessionId}}}{AvgTime} = (${Nodes{$SSReq{SessionId}}}{PreLastTime} == 0 ? ${Nodes{$SSReq{SessionId}}}{LastTime} : int((${Nodes{$SSReq{SessionId}}}{LastTime}+${Nodes{$SSReq{SessionId}}}{PreLastTime})/2));
      
      $NodesASWCount{${Nodes{$SSReq{SessionId}}}{Id}}++;
      $RequestsPerMinute++;
      print "P> ".${Nodes{$SSReq{SessionId}}}{Id}.": ASW $SSReq{PortionNumber}\n" if !$::ts_debugHideProcessorOut;
      # alarm ($::ts_portionWait) if ($::ts_singlePortion == 1);
    }
    elsif ($SSReq{ReqType} eq 'TSR' && !(($LastAskedPortion==$LastPortionNumber) && ($::ts_singlePortion==1)))
    {
      my $SessionId = XServUtils::GetUniqueID();
      # $SessionId =~ s/\.//; print STDERR $SessionId;
      my %NewNode=( Id=>$SSReq{NodeId}, IP=>$SSReq{NodeIP}, CPU=>$SSReq{CPUCores}.'x '.$SSReq{CPUType}.' '.sprintf("%.2f",$SSReq{CPUFreq}/100000).' MHz', RAM=>sprintf("%.2f",$SSReq{RAMSize}/1048576), OS=>$SSReq{OSType}, CPUType=>$SSReq{CPUType}, Portion=>-1, LastTime=>0, PreLastTime=>0, AvgTime=>0);
      $Nodes{$SessionId}=\%NewNode;
      $TotalNodesCount++;
      if (!exists($UniqueNodesKeys{$SSReq{NodeId}}))
      {
	$UniqueNodesKeys{$SSReq{NodeId}} = $SessionId;
        #$TotalPeakPerformance += $SSReq{CPUCores}*$SSReq{CPUPerf};
	$TotalPeakPerformance += $SSReq{CPUPerf};
	$TotalUniqueNodesCount++;
      }

#print STDERR Dumper(%Nodes);
      # push (@Data4SServer, $SessionId, $::ts_taskName, $::ts_taskId, $::ts_taskArgs, $::ts_dlSites_s);
      push (@Data4SServer, $SessionId);
#      XServUtils::LogWrite($SSReq{NodeIP}, $SSReq{NodeId}.':TSR');
      $NodesASWCount{${Nodes{$SessionId}}{Id}} = 0 if (!exists( $NodesASWCount{${Nodes{$SessionId}}{Id}} ));
      $RequestsPerMinute++;
      print "P> ".${Nodes{$SessionId}}{Id}.": TSR\n";
    }
    elsif ($SSReq{ReqType} eq 'STA')
    {
      my $TotalPortions;
      # 0 - task name
      # 1 - task id
      # 2 - task arguments
      # 3 - start timestamp
      # 4 - current timestamp
      # 5 - total portions number
      # 6 - last asked portion number
      # 7 - portions in process
      # 8 - sent portions count
      # 9 - total recievied portions count 
      # 10 - unique received portions count
      # 11 - total unique nodes count
      # 12 - total peak performance
      # 13 - total nodes (sessions) count
      # 14 - requests per minute
      push (@Data4SServer, $::ts_taskName, $::ts_taskId, ($::ts_taskArgs eq '' ? ' ' : $::ts_taskArgs), $::StartTime, my $ct=time());
      push (@Data4SServer, $TotalPortions=$LastPortionNumber-$FirstPortionNumber+1, $LastAskedPortion, scalar(@PortionsInProcess), $SentPortionsCount, $ReceivedPortionsCount, $UniqueReceivedPortionsCount, $TotalUniqueNodesCount, $TotalPeakPerformance, $TotalNodesCount, sprintf ("%.2f",$RequestsPerMinute/(time()-$time4RPM+1))); # sprintf("%.2f",100*($UniqueReceivedPortionsCount/$TotalPortions))
      foreach my $NodeSID (keys %Nodes)
      {
#print STDERR ${$Nodes{$NodeSID}}{Id};
	push (@Data4SServer, ${$Nodes{$NodeSID}}{Id}.':'.${$Nodes{$NodeSID}}{Portion}.':'.(defined (${$Nodes{$NodeSID}}{Start}) ? ($ct-${$Nodes{$NodeSID}}{Start}) : 0).':'.${$Nodes{$NodeSID}}{AvgTime}.':'.${$Nodes{$NodeSID}}{IP}.':'.(defined(${$Nodes{$NodeSID}}{CPUType}) ? ${$Nodes{$NodeSID}}{CPUType} : 'unknown').':'.(defined(${$Nodes{$NodeSID}}{OS}) ? ${$Nodes{$NodeSID}}{OS} : 'unknown').':'.$NodeSID.':'.$NodesASWCount{${$Nodes{$NodeSID}}{Id}});
      }
    }
    elsif ($SSReq{ReqType} eq 'INI')
    {
      push (@Data4SServer, $::ts_taskName, $::ts_taskId, $::ts_taskArgs);
    }
    else
    {
      push (@Data4SServer, 'ERR');
      $ErrCode = 1;
#print STDERR "\nP> ERR\n";
      print STDERR "P> Unexpected client!\n";
    }
#my $time2 = time();
#print STDERR "TSP ($SSReq{ReqType}): ".@Data4SServer."\n";;
#print STDERR Dumper @Data4SServer;
#print STDERR "TSP \n";
    if (($SSReq{ReqType} ne 'REQ') || ($ErrCode != 0))
    {
#print STDERR "SENDING $SSReq{ReqType}: <".join("\n",@Data4SServer)."\n\n>";
      print $SubServer join ($EOL, @Data4SServer).$EOL x 2;
#print STDERR "SENT\n";
    }
#print STDERR $Data4SServer[0] if ($SSReq{ReqType} eq 'ASW');
    close $SubServer;
    $ErrCode = 0 if $ErrCode != 0;
#my $time3 = time();
#print STDERR "PT> ".($time1-$time0).' : '.($time2-$time1).' : '.($time3-$time2)."\n";
    $LastRequestTime = time();
    if (@PortionsInProcess==0 && (($LastAskedPortion==$LastPortionNumber) || (($LastPortionNumber==0) && (XServAPI::IsFinished()==1))))
    {
      print STDERR "P> Finishing communications...\n";
      close $TaskServer;
      sleep(2);
      # XServAPI::Finalize();
      return(1);
    }
  }
}

1;
