package XServProxy;

use LWP::UserAgent;

use Data::Dumper;
# use Carp;
# $SIG{__DIE__} = \&confess;

our $proxyDir;

sub proxyGetPortions
{
  my ($q, $path) = @_;
  my $pserver = (defined $::ts_proxyREQServer ? $::ts_proxyREQServer : $::ts_upServer);
  if (lc($pserver=~/^https/)){init_SSL_defaults();}
  my $ua = LWP::UserAgent->new();
  if (lc($pserver=~/^https/)){$ua = init_SSL($ua);}
  $ua->proxy('http', $::ts_httpProxy) if (defined($::ts_httpProxy));
  my $xml_getports = "<get-portion client-id=\"$::ts_clId\" task-name=\"$::ts_taskName\" task-id=\"$::ts_taskId\" session-id=\"$::ts_sessId\" q=\"$q\" />";
  my $resp;
  # my $pserver = (defined $::ts_proxyREQServer ? $::ts_proxyREQServer : "http://$::ts_upHost:$::ts_upPort");  
  while (1)
  {
    $resp = $ua->post($pserver, Content=>$xml_getports);
    last if ($resp->is_success());
    print STDERR "XServProxy(Get): cannot connect to $pserver, retrying...\n";
    sleep (1);
  }
  my @resp_parts = $resp->parts();
  my $p = new XML::Parser(Style => 'Objects');
#my $prtdata = (@resp_parts == 0 ? $p->parse(resp->decoded_content()) : $p->parse((shift(@resp_parts))->decoded_content()));
#print STDERR Dumper ($prtdata);
#  return 0 if ($prtdata->[0]->isa('XServProxy::initialize'));
  my $prtdata;
  if (@resp_parts != 0)
  {
    $prtdata = $p->parse((shift(@resp_parts))->decoded_content());
  }
  else
  {
    return 0;
  }
#print STDERR $xml_in;
  my $pc = 0; my $pnum; my $pargs;
  foreach my $r (@resp_parts)
  {
#print STDERR Dumper $prtdata->[0]->{Kids}->[$pc]->{'num'};
    $pnum = $prtdata->[0]->{Kids}->[$pc]->{'num'};
    $pargs = $prtdata->[0]->{Kids}->[$pc]->{'args'};
    open F, "> $path/$pnum.dat" or die "XServProxy(proxyGetPortions): can't write to $path/$pnum.dat!\n";
    binmode F;
    print F $r->decoded_content();
    close F;
    open F, "> $path/$pnum.arg" or die "XServProxy(proxyGetPortions): can't write to $path/$pnum.arg!\n";
    print F $pargs;
    close F;
    push (@::InBufferPortions, $pnum);
    $pc++;
  }
  return $pc;
}

sub proxySendPortions
{
  my $pserver = (defined $::ts_proxyASWServer ? $::ts_proxyASWServer : $::ts_upServer);
  if (lc($pserver=~/^https/)){init_SSL_defaults();}
  my ($q, $path) = @_;
  my @data;
  my $pc = 0;
  my $ua = LWP::UserAgent->new();
  my $pt = 0;
  if (lc($pserver=~/^https/)){$ua = init_SSL($ua);}
  $ua->proxy('http', $::ts_httpProxy) if (defined($::ts_httpProxy));
  my $xml_prt = ""; my $pnum; my $buf;
  while ($pc < $q)
  {
    $pnum = shift (@::OutBufferPortions);
    # open F, "< $path/$pnum.dat" or die ("XServProxy(proxySendPortions): can't read from $path/$pnum.dat!\n");
    my $pfile = ( @::OutBufferPortionsPath > 0 ? shift @::OutBufferPortionsPath : "$path/$pnum" );
    if ( -e "$pfile.dat" )
    {
      open F, "< $pfile.dat" or die ("XServProxy(proxySendPortions): can't read from $pfile.dat!\n");
      read (F, $buf, -s F);
      close F;
    }
    else
    {
      $buf = '';
      print STDERR "XServProxy(proxySendPortions) warning: portion $pnum is empty!\n";
    }
    if ( -e "$pfile.wt" )
    {
      open T, "< $pfile.wt";
      my $ptc = <T>;
      close T;
      $pt = $ptc if ($ptc =~ /^-?\d+\.?\d*$/);
    }
    $pc++;
    push (@data, $pc, $buf);
    $xml_prt.="<result-data num=\"$pnum\" size=\"".length($buf)."\" time=\"$pt\"></result-data>";
  }
  my $xml_sendports = "<post-result client-id=\"$::ts_clId\" task-name=\"$::ts_taskName\" task-id=\"$::ts_taskId\" session-id=\"$::ts_sessId\" q=\"$pc\">$xml_prt</post-result>";
#print STDERR "\n$xml_sendports\npc = $pc\n";
  unshift (@data, 0, $xml_sendports);
  my $resp;
  # my $pserver = (defined $::ts_proxyASWServer ? $::ts_proxyASWServer : "http://$::ts_upHost:$::ts_upPort");
  my $pserver = (defined $::ts_proxyASWServer ? $::ts_proxyASWServer : $::ts_upServer);
  while (1)
  {  
    $resp = $ua->post($pserver, Content_Type=>'form-data', Content=>\@data);
    last if ($resp->is_success());
    print STDERR "XServProxy(Send): cannot connect to $pserver, retrying...\n";
    sleep (1);
  }
  my $dresp = $resp->decoded_content();
  chomp $dresp;
  return ($dresp ne '<initialize />' ? $pc : 0); 
}

sub proxyInit
{
  if (lc($::ts_upServer=~/^https/))  { init_SSL_defaults(); }
  $::ts_outBufferSize = $::ts_inBufferSize = 0;
  @::InBufferPortions = @::OutBufferPortions = ();
  my $xml_gettask = "<get-task><client id=\"$::ts_clId\"><cpu type=\"$::ts_clCPUType\" num-cores=\"$::ts_clCPUCores\" freq=\"$::ts_clCPUFreq\" perf=\"$::ts_clCPUPerf\" /><ram size=\"$::ts_clRAMSize\" /><os type=\"$::ts_clOS\" /></client></get-task>";
#print STDERR $xml_gettask;
  my $ua = LWP::UserAgent->new();
  if (lc($::ts_upServer=~/^https/))  {$ua = init_SSL($ua);}  
  $ua->proxy('http', $::ts_httpProxy) if (defined($::ts_httpProxy));
  # push @{ $ua->requests_redirectable }, 'POST';
  my $resp;
  while (1)
  {
    $resp = $ua->post($::ts_upServer, Content=>$xml_gettask);
    last if ($resp->is_success());
    print STDERR "XServProxy(Init): cannot connect to $::ts_upServer, retrying...\n";
    sleep (1);
  }
  my $p = new XML::Parser(Style => 'Objects');
  my $req = $p->parse($resp->content);
  $::ts_sessId = $req->[0]->{'session-id'};
  $::ts_taskName = $req->[0]->{'task-name'};
  $::ts_taskId = $req->[0]->{'task-id'};
  $::ts_taskArgs = $req->[0]->{'task-args'};
  $::ts_xCliAPI = $req->[0]->{'api'};
  if ($::ts_xCliAPI eq 'Processes')
  {
    $::ts_xCliInitCmd = $req->[0]->{Kids}->[4]->{Kids}->[0]->{Text};
    $::ts_xCliPortionCmd = $req->[0]->{Kids}->[5]->{Kids}->[0]->{Text};
    $::ts_xCliPortionIn = $req->[0]->{Kids}->[5]->{'portion'};
    $::ts_xCliPortionOut = $req->[0]->{Kids}->[5]->{'result'};
  }

  print STDERR " Task name:\t\t$::ts_taskName\n Task ID:\t\t$::ts_taskId\n Task arguments:\t$::ts_taskArgs\n\n";
  XServUtils::LogWrite2($ARGV[0],'START','Server='.$::ts_ssHost.'&STime='.Time::HiRes::time().'&TaskAPI='.$::ts_taskAPI.($::ts_taskAPI eq 'Subserver' ? '' : '&TaskName='.$::ts_taskName.'&TaskId='.$::ts_taskId.'&TaskArgs={'.$::ts_taskArgs.'}'));

  $proxyDir = "$::ts_proxyTmp/$::ts_taskName.$::ts_taskId.$::ts_sessId";
  mkdir $proxyDir;
  # unlink <$proxyDir/*.*>;
  mkdir "$proxyDir/in";
  # unlink <$proxyDir/in/*.*>;
  mkdir "$proxyDir/out";
  # unlink <$proxyDir/out/*.*>;

  my $xml = $req->[0]->{'Kids'};
#print STDERR Dumper $efiles;

  my $fflag = 1;
  foreach my $ef (@$xml)
  {
    # Taking and working with only 1st URL in list..
    # Should be extended in future to support all URL list features
    if ($ef->isa(XServProxy::file))
    {
      my $efile = $ef->{filename};
      $::proxy_taskArchive = $efile;
      my $eurl = $ef->{Kids}->[0]->{Kids}->[0]->{Text};
      $resp = $ua->get($eurl.'?client-id='.$::ts_clId, ":content_file"=>"$proxyDir/$efile");
      die ("XServProxy(Init): can't get $eurl to $proxyDir/$efile\n") if (!$resp->is_success());
      $::ts_dlFiles{$efile} = $proxyDir if ($fflag == 0);
      $fflag = 0;
    }
    elsif ($ef->isa('XServProxy::portion-server'))
    {
      $::ts_proxyREQServer = $ef->{Kids}->[0]->{Kids}->[0]->{Text};
    }
    elsif ($ef->isa('XServProxy::result-server'))
    {
      $::ts_proxyASWServer = $ef->{Kids}->[0]->{Kids}->[0]->{Text};
    }
  }

  print STDERR "XServProxy: task received\n";

  $::ts_inBufferSize = proxyGetPortions ($::ts_inBufferStart, "$proxyDir/in") ;
  print STDERR "XServProxy: input buffer ready ($::ts_inBufferStart)\n";
}


sub init_SSL_defaults()
{
  require LWP::Protocol::https;  
  if (defined ($::ts_SSL_trusted_dir))
  {
    $ENV{HTTPS_CA_DIR}  = $::ts_SSL_trusted_dir; #despite new LWP with explicit SSL configuration,
    # removal of this variable causes miserable certificate verification failure
    # should be assigned BEFORE $ua is created
  }
  if ((defined $::ts_SSL_cert_file) && (defined $::ts_SSL_key_file) && (defined $::ts_SSL_trusted_dir))
  {
    $ENV{HTTPS_CERT_FILE} = $::ts_SSL_cert_file;
    $ENV{HTTPS_KEY_FILE}  = $::ts_SSL_key_file;
  }  
}

sub init_SSL()
{
  require LWP::Protocol::https;
  my $ua = shift;          
  if (defined $ua->ssl_opts) #new version of LWP on IO::Socket::SSL - to be configured by hand: some of $env are somehow ignored under mswin32
  {
    if ((defined $::ts_SSL_trusted_dir))
    {
      $ua->ssl_opts(
      SSL_ca_path => $::ts_SSL_trusted_dir,
      SSL_verify_mode => 0x03
      );
    }
    if ((defined $::ts_SSL_cert_file) && (defined $::ts_SSL_key_file) && (defined $::ts_SSL_trusted_dir))
    {      
      $ua->ssl_opts(
      SSL_ca_path => $::ts_SSL_trusted_dir,      
      SSL_key_file => $::ts_SSL_key_file,
      SSL_cert_file => $::ts_SSL_cert_file,      
      SSL_verify_mode => 0x03
      );
    }    
  } 
  return $ua;
}

1;