package XServProxyQueueLL;

require Exporter;
our @ISA = qw(Exporter);
our @EXPORT = qw(queue_init queue_found_tasks queue_helper queue_name);

use strict;
use warnings;

sub queue_init
{ 
  mkdir "$XServProxyQueue::uTaskPath/work" if $::ts_xCliAPI eq 'Processes';
  return 1;
}

sub queue_found_tasks
{
  my %ft = ();
  my $run = `llq`;
  foreach (keys %XServProxyQueue::QueuedPortions)
  {
    $ft{$_} = 1 if $run =~ /\.$_\./;
  }
  return %ft;
}

sub queue_helper
{
  my ($p, $pc) = @_;
  my $helper = XServProxyQueue::helper_name ($p);
  my $args = XServProxyQueue::portion_getargs ($p);
  # (defined $::ts_llTPN ? "# @ tasks_per_node = $::ts_llTPN\n" : '')
  my $ch = (defined $::ts_llClass ? "# @ class = $::ts_llClass\n" : '').(defined $::ts_llNodes ? "# @ node = $::ts_llNodes\n" : '').(defined $::ts_queueTimeLimit ? "# @ wall_clock_limit = $::ts_queueTimeLimit\n" : '')."# @ queue\n";
  if ($::ts_xCliAPI eq 'Perl')
  {
    $ch .= "perl -mTime::HiRes -e \"my \\\$start=Time::HiRes::time(); eval {do 'gctask'; gctask ('$::ts_taskName','$args','$p','$XServProxyQueue::uTaskPath/in/$p.dat','$XServProxyQueue::uTaskPath/out/$p.$pc.dat')}; open WH, '> $XServProxyQueue::uTaskPath/out/$p.$pc.wt'; print WH Time::HiRes::time()-\\\$start; close WH\"\n";
  }
  elsif ($::ts_xCliAPI eq 'Processes')
  {
    $ch .="mkdir $XServProxyQueue::uTaskPath/work/$p
cp -l * $XServProxyQueue::uTaskPath/work/$p
cd $XServProxyQueue::uTaskPath/work/$p
cp -l $XServProxyQueue::uTaskPath/in/$p.dat $::ts_xCliPortionIn
./$::ts_xCliPortionCmd
cp $::ts_xCliPortionOut $XServProxyQueue::uTaskPath/out/$p.$pc.dat
cd $XServProxyQueue::uTaskPath
rm $XServProxyQueue::uTaskPath/work/$p/*
rmdir $XServProxyQueue::uTaskPath/work/$p
";
  }
  open CH, "> $helper";
  print CH $ch;
  close CH;
  my $cmdstr = "llsubmit $helper";
  my $cr = $::ts_queueRetries;
  my $id = 0;
  do
  {
    my $run = `$cmdstr`;
    if ($run =~ /\.(\d+)\"/)
    { $id = $1 }
    else { print STDERR "helper: llsubmit said: $run".($cr > 1 ? "helper: retrying...\n" : '') }
    $cr--;
  } while ( ($id == 0) && ($cr > 0) );
  return $id;
}

sub queue_name
{
  return (defined $::ts_llClass ? $::ts_llClass : 'No_Class');
}

1;