package XServProxyQueueTorque;

require Exporter;
our @ISA = qw(Exporter);
our @EXPORT = qw(queue_init queue_found_tasks queue_helper queue_name);

use strict;
use warnings;

sub queue_init
{ 
  mkdir "$XServProxyQueue::uTaskPath/work" if $::ts_xCliAPI eq 'Processes';
  return 1; 
}

sub queue_found_tasks
{
  my %ft = ();
  my $run = `qstat`;
  foreach (keys %XServProxyQueue::QueuedPortions)
  {
    $ft{$_} = 1 if $run =~ /\n$_\./;
  }
  return %ft;
}

sub queue_helper
{
  my ($p, $pc) = @_;
  my $helper = XServProxyQueue::helper_name ($p);
  my $args = XServProxyQueue::portion_getargs ($p);
  my $ch = "#!/bin/sh
#PBS -d $XServProxyQueue::uTaskPath
#PBS -l ncpus=$::ts_queueNP
#PBS -o /dev/null
#PBS -e /dev/null
".(defined $::ts_queueTimeLimit ? "#PBS -l walltime=$::ts_queueTimeLimit\n" : '');
  if ($::ts_xCliAPI eq 'Perl')
  {
    $ch .= "#PBS -d $XServProxyQueue::uTaskPath
perl -mTime::HiRes -e \"my \\\$start=Time::HiRes::time(); eval {do 'gctask'; gctask ('$::ts_taskName','$args','$p','$XServProxyQueue::uTaskPath/in/$p.dat','$XServProxyQueue::uTaskPath/out/$p.$pc.dat')}; open WH, '> $XServProxyQueue::uTaskPath/out/$p.$pc.wt'; print WH Time::HiRes::time()-\\\$start; close WH\"\n";
  }
  elsif ($::ts_xCliAPI eq 'Processes')
  {
    $ch .= "mkdir $XServProxyQueue::uTaskPath/work/$p
cp -l * $XServProxyQueue::uTaskPath/work/$p
cd $XServProxyQueue::uTaskPath/work/$p
cp -l $XServProxyQueue::uTaskPath/in/$p.dat $::ts_xCliPortionIn
./$::ts_xCliPortionCmd
cp $::ts_xCliPortionOut $XServProxyQueue::uTaskPath/out/$p.$pc.dat
cd $XServProxyQueue::uTaskPath
rm $XServProxyQueue::uTaskPath/work/$p/*
rmdir $XServProxyQueue::uTaskPath/work/$p
";
  }
  open CH, "> $helper";
  print CH $ch;
  close CH;
  my $cmdstr = "qsub $helper";
#print STDERR $cmdstr."\n";
  my $cr = $::ts_queueRetries;
  my $id = 0;
  do
  {
    my $run = `$cmdstr`;
    if ($run =~ /^(\d+)\./)
    { $id = $1 }
    else { print STDERR "helper: qsub said: $run".($cr > 1 ? "helper: retrying...\n" : '') }
    $cr--;
  } while ( ($id == 0) && ($cr > 0) );
  return $id;
}

sub queue_name
{
  return 'batch';
}

1;