package XServUtils;

sub GetTaskFilename
{
  my ($task, $os, $cpu) = @_;
  my $ext='.tar.gz';
  #if ($os =~ /linux/i) { return $task.'-L'.$ext};
  $cpu='x86' if ($cpu eq 'unknown');
  $os='linux' if ($os eq 'unknown');
  return $task.'-'.$os.'-'.$cpu.$ext;
}

sub GetUniqueID
{
  my ($sec,$msec) = Time::HiRes::gettimeofday();
  return $sec.'0' x (6-length($msec)).$msec;
}

sub LogWrite
{
  my ($ip, $msg) = @_;
  my ($sec, $msec) = Time::HiRes::gettimeofday();
  my @tTime = localtime($sec);
  my $str = ($tTime[5]+1900).'-'.($tTime[4] < 9 ? '0' : '').($tTime[4]+1).'-'.($tTime[3] < 10 ? '0' : '').$tTime[3].' '.($tTime[2] < 10 ? '0' : '').$tTime[2].'-'.($tTime[1] < 10 ? '0' : '').$tTime[1].'-'.($tTime[0] < 10 ? '0' : '').$tTime[0].'.'.$msec."\t".$ip."\t".$msg."\n";
  #open (LOG, ">> $::ts_logFile");
  print ::LOG $str;
  #print LOG $str;
  #close LOG;
#  print STDERR $str;
}

sub LogWrite2
{
  my ($ip, $req, $msg) = @_;
  my ($sec, $msec) = Time::HiRes::gettimeofday();
  my @tTime = localtime($sec);
  my $str = ($tTime[5]+1900).'-'.($tTime[4] < 9 ? '0' : '').($tTime[4]+1).'-'.($tTime[3] < 10 ? '0' : '').$tTime[3].' '.($tTime[2] < 10 ? '0' : '').$tTime[2].'-'.($tTime[1] < 10 ? '0' : '').$tTime[1].'-'.($tTime[0] < 10 ? '0' : '').$tTime[0].'.'.$msec."\t".$ip."\t".$req."\t".$msg."\n";
  print ::LOG $str;
}

sub GenerateStatML
{
  my ($data, $type, $refresh) = @_;
  my %nodes=();
  my $DF = 15;
  for (my $i=$DF; $i<=$#$data; $i++)
  {
    my $s=@$data[$i];
#print STDERR $s."\n";
    if ($s =~ /([^:]+):([^:]+):([^:]+):([^:]+):([^:]+):([^:]+):([^:]+):([^:]+):([^:]+)/)
    {
      my $node=$1; my $pn=$2; my $pt=$3; my $at=$4; my $ip=$5; my $cpu=$6; my $os=$7; my $sid=$8; my $asws=$9;
      my %tmpnode1 = ('N'=>$pn, 'T'=>$pt, 'A'=>$at, 'IP'=>$ip, 'CPU'=>$cpu, 'OS'=>$os, 'SID'=>$sid, 'ASWS'=>$asws);
      my ($node_name, $node_cpu);
      if ($node =~ /(.+)\.(\d+)/)
      {
	$node_name=$1; $node_cpu=$2;
      }
      else
      {
        $node_name=$node; $node_cpu=0;
      }
      if (!exists(${$nodes{$node_name}}{$node_cpu}))
      {
	$tmpnode1{RET}=0;
	${$nodes{$node_name}}{$node_cpu} = \%tmpnode1;
      }
      else
      {
	${${$nodes{$node_name}}{$node_cpu}}{RET}++;
	if (${${$nodes{$node_name}}{$node_cpu}}{SID} < $sid)
	{
	  $tmpnode1{RET}=${${$nodes{$node_name}}{$node_cpu}}{RET};
	  ${$nodes{$node_name}}{$node_cpu} = \%tmpnode1;
	}
      }
    }
  }
  my $num_nodes = keys %nodes;
  my $MLStat; 
  my $rt_s = @$data[4] - @$data[3];
  my $rt_h = int ($rt_s/(60*60));
  my $rt_m = int (($rt_s - $rt_h*60*60)/60);
  $rt_s = $rt_s - $rt_h*60*60 - $rt_m*60;
  my $completed = int(100*@$data[10]/@$data[5]);
  my $perf = sprintf("%.2f",@$data[12]/1000000000);
  if ($type eq 'HTML')
  {
    $MLStat = "<html>
<head>
".($refresh !=0 ? "<meta http-equiv=refresh content=$refresh>\n" : '')."<title>$completed% @$data[0].@$data[1]@".$::ts_ssHost."</title>
<style>
tr { font-size: 12px; font-family: Arial }
tr.header { background-color: #000000; color: #FFFFFF }
tr.data1,td.data1 { background-color: #CCCCCC; color: #000000 }
.notask,.rnotask { color: #7F7F7F }
.ok,.rok { color: #000000 }
.nores,.rnores { color: #007B00 }
.rnotask,.rok,.rnores { font-style: italic }
</style>
</head>
<body>
<table width=100% border=1>
<tr class=header><td width=100% colspan=2><table width=100% border=0 cellspacing=0 cellpadding=0><tr class=header><td width=10% align=left> @$data[0].@$data[1]</td><td width=80% align=center>@$data[2]</td><td width=10% align=right>$rt_h:".($rt_m<10?'0':'')."$rt_m:".($rt_s<10?'0':'')."$rt_s </td></tr></table></td></tr>
<tr><td width=".($completed == 0 ? 1 : $completed)."% align=center class=data1><b>$completed%</b></td><td></td></tr>
</table>
<table width=100% border=1>
<tr class=header><td colspan=2 width=33.3%>Nodes</td><td colspan=2 width=33.3%>Portions</td><td colspan=2>Performance</td></tr>
<tr class=data1><td align=right>Hosts:</td><td>$num_nodes</td><td align=right>Total:</td><td>@$data[5]</td><td align=right>Peak:</td><td>$perf GFlops</td></tr>
<tr class=data1><td align=right>Clients:</td><td>@$data[11]</td><td align=right>Last:</td><td>@$data[6]</td><td align=right>Requests/sec:</td><td>@$data[14]</td></tr>
<tr class=data1><td align=right>Sessions:</td><td>@$data[13]</td><td align=right>Completed:</td><td>@$data[10]</td><td align=right>Sent/Received:</td><td>@$data[8]/@$data[9]</td></tr>
</table>
<p>
<table width=100% border=1>
<tr class=header><td colspan=3>Computational map</td></tr>
";
    foreach my $k1 (sort keys %nodes)
    {
      $MLStat .= "\n<tr><td>$k1</td>";
      my $ndata='';
      foreach my $k2 (sort keys %{$nodes{$k1}})
      {
	if ($ndata eq '')
	{
	  $ndata = "<td><nobr>IP: ${${$nodes{$k1}}{$k2}}{IP}</nobr><br><nobr>Arch: ${${$nodes{$k1}}{$k2}}{CPU}/${${$nodes{$k1}}{$k2}}{OS}</nobr></td><td>";
	  $MLStat .= $ndata;
	}
	my $sc = ${${$nodes{$k1}}{$k2}}{N} == -1 ? 'notask' : (${${$nodes{$k1}}{$k2}}{ASWS} == 0 ? 'nores' : 'ok');
	$sc = 'r'.$sc if (${${$nodes{$k1}}{$k2}}{RET} > 0);
	$MLStat .= "<nobr><span class=$sc>#=".$k2.", P<sub>num</sub>=${${$nodes{$k1}}{$k2}}{N}, T<sub>curr</sub>=${${$nodes{$k1}}{$k2}}{T}, T<sub>avg</sub>=${${$nodes{$k1}}{$k2}}{A}, N<sub>asw</sub>=${${$nodes{$k1}}{$k2}}{ASWS}, N<sub>ret</sub>=${${$nodes{$k1}}{$k2}}{RET}; </span></nobr> ";
      }
      $MLStat .= "</td></tr>";
    }

    $MLStat .= "<tr><td colspan=3>Legend: # - proccess number, P<sub>num</sub> - current portion number, T<sub>curr</sub> - current portion time, T<sub>avg</sub> - average portion time, N<sub>asw</sub> = number of processed portions, N<sub>ret</sub> = number of clients restarts
<br>Styles: <span class=notask>retrieving task (P<sub>num</sub>=-1)</span>, <span class=nores>processing 1st portion (N<sub>asw</sub>=0)</span>, <span class=ok>processing other portions (N<sub>asw</sub>&gt;0)</span>, <span class=rok>restarted client (N<sub>ret</sub>&gt;0)</span></td></tr>
</table>
</body>
</html>";
  }
  elsif ($type eq 'XML')
  {
    $MLStat = "<task name=\"@$data[0].@$data[1]\" desc=\"\" runtime=\"$rt_h:$rt_m:$rt_s\" completed=\"$completed\">
<portions total=\"@$data[5]\" done=\"@$data[10]\" last=\"@$data[6]\" />
<performance peak=\"$perf\" efficiency=\"90%\" />
<nodes total=\"@$data[11]\" working=\"@$data[11]\" communicating=\"0\">";
    foreach my $k1 (sort keys %nodes)
    {
      $MLStat .= "<node name=\"$k1\" OS=\"LX\">";
      foreach my $k2 (sort keys %{$nodes{$k1}})
      {
	$MLStat .= "<cpu number=\"$k2\" portion=\"${${$nodes{$k1}}{$k2}}{N}\" time=\"${${$nodes{$k1}}{$k2}}{T}\" average=\"0\" conn=\"0\" />";
      }
      $MLStat .= "</node>";
    }
    $MLStat .= "
</nodes>
</task>";
  }
  return $MLStat;
}

1;