#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <errno.h>
#include <time.h>
unsigned long long pow_ull(unsigned int base, unsigned int e)
{
	unsigned long long r = 1;
	for (unsigned int i = 0; i < e; i = i + 1)
	{
		r = r * base;
		if (errno==ERANGE)
		{
			return -1;
		}
	}
	return r;
}
int main (int argc, char* argv[])
{
	//parsing command line arguments
	//pointer to the character which failes argument parsing in strtoul
	char* end_ptr;
	if (argc!=2)
	{
		printf("-1\n");
		return 1;
	}
	unsigned int E = strtoul(argv[1],&end_ptr,10);
	if (errno==ERANGE || *end_ptr)
	{
		printf("-1\n");
		return 1;
	}
	unsigned long long dropsCount = pow_ull(10, E);	
	//dropsCount=10**E;
	unsigned long long dropsSum = 0;
	//setting random number generator seed
	srand(time(NULL));
	for (unsigned long long i = 0; i < dropsCount; i = i + 1)
	{
		double x = rand() / (double) RAND_MAX;
		double y = rand() / (double) RAND_MAX;
		//if drop falls inside circle
		if (x * x + y * y < 1)
		{
			//increment the dropsSum by 4
			dropsSum = dropsSum + 4;
		}
	}
	printf("%lld",dropsSum);
	return 0;
}

