#define MA(i,j) A[i+SZ*j]
#define MB(i,j) B[i+SZ*j]
#define MC(i,j) C[i+SZ*j]
#include <stdio.h>
#include <time.h>
#include <stdlib.h>

long SZ;
typedef int type;
type *A,*B,*C;

type rnd()
{
  return ((type)rand());
}

int main (int argc, char *argv[])
{
  long i,j,k,msz,maxtime=-1;
  time_t start;
  start=time(NULL);
  if (argc==1)
  {
    fprintf(stderr, "Usage: %s <MATRIX_SIZE> [<MAX_TIME>]\n", argv[0]);
    exit(-1);
  }
  SZ=atol(argv[1]);
  msz=SZ*SZ*sizeof(type);
  if (argc==3)
    maxtime=atol(argv[2]);
  printf("Allocating memory...\n");
  if ((A=(type*)malloc(msz))==NULL)
  {
    fprintf(stderr, "%s: cannot allocate %ld bytes for A!\n", argv[0],msz);
    exit(-1);
  }
  if ((B=(type*)malloc(msz))==NULL)
  {
    fprintf(stderr, "%s: cannot allocate %ld bytes for B!\n", argv[0],msz);
    exit(-1);
  }
  if ((C=(type*)malloc(msz))==NULL)
  {
    fprintf(stderr, "%s: cannot allocate %ld bytes for C!\n", argv[0],msz);
    exit(0);
  }
  srand(time(NULL));
  printf("Initializing matrixes...\n");
  for (i=0; i<SZ; i++)
  {
    for (j=0; j<SZ; j++)
    {
      MA(i,j)=rnd();
      MB(i,j)=rnd();
      if (maxtime>=0 && difftime(time(NULL),start)>maxtime)
      {
        fprintf(stderr,"Interrupted by timer (%ld s)!\n",maxtime);
	exit(0);
      }
    }
  }
  printf("Starting calculations...\n");
  for (i=0; i<SZ; i++)
  {
    for (j=0; j<SZ; j++)
    {
      for (k=0; k<SZ; k++)
      {
        MC(i,j)=MC(i,j)+MA(i,k)*MB(k,j);
        if (maxtime>=0 && difftime(time(NULL),start)>maxtime)
	{
	  fprintf(stderr,"Interrupted by timer (%ld s)!\n",maxtime);
          exit(0);
	}
      }
    }
  }    
  printf("Done in %ld s.\n",(long)difftime(time(NULL),start));
  exit(1);
}
